require 'rails_helper'

# This spec was generated by rspec-rails when you ran the scaffold generator.
# It demonstrates how one might use RSpec to test the controller code that
# was generated by Rails when you ran the scaffold generator.
#
# It assumes that the implementation code is generated by the rails scaffold
# generator. If you are using any extension libraries to generate different
# controller code, this generated spec may or may not pass.
#
# It only uses APIs available in rails and/or rspec-rails. There are a number
# of tools you can use to make these specs even more expressive, but we're
# sticking to rails and rspec-rails APIs to keep things simple and stable.

RSpec.describe '/tools/rca_lists', type: :request do
  let(:valid_attributes) { {rca_id: rca.id, tool_reference: 1} }
  let(:invalid_attributes) { {rca_id: nil, tool_reference: 1} }

  let(:rca) { FactoryBot.create(:rca, methodology: methodology) }
  let(:methodology) { FactoryBot.create(:methodology, :with_step_1) }
  let(:user) { FactoryBot.create(:user) }

  # describe 'GET /show' do
  #   it 'renders a successful response' do
  #     tools_rca_list = Tools::RcaList.create! valid_attributes
  #     get tools_rca_list_url(tools_rca_list)
  #     expect(response).to be_successful
  #   end
  # end

  context 'From logged user' do
    before :each do
      # binding.pry
      user.set_session(:active_step_tool, methodology.steps.first.step_tools.first.id)
      user.save!

      sign_in user
    end

    describe 'GET /edit' do
      it 'render a successful response' do
        tools_rca_list = Tools::RcaList.create! valid_attributes
        get edit_tools_rca_list_url(tools_rca_list)
        expect(response).to be_successful
      end
    end

    describe 'PATCH /update' do
      context 'with valid parameters' do
        let(:new_attributes) { {rca_id: rca.id, tool_reference: 1, description: 'nouvelle description'} }

        it 'updates the requested tools_rca_list' do
          tools_rca_list = Tools::RcaList.create! valid_attributes
          patch tools_rca_list_url(tools_rca_list), params: { tools_rca_list: new_attributes }
          tools_rca_list.reload
          expect(tools_rca_list.description).to eq 'nouvelle description'
        end

        it 'redirects to the tools_rca_list' do
          tools_rca_list = Tools::RcaList.create! valid_attributes
          patch tools_rca_list_url(tools_rca_list), params: { tools_rca_list: new_attributes }
          tools_rca_list.reload
          expect(response).to redirect_to(edit_tools_rca_list_url(tools_rca_list))
        end
      end

      context 'with invalid parameters' do
        it 'renders a successful response (i.e. to display the edit template)' do
          tools_rca_list = Tools::RcaList.create! valid_attributes
          patch tools_rca_list_url(tools_rca_list), params: { tools_rca_list: invalid_attributes }
          expect(response).to be_successful
        end
      end
    end
  end
end
